/*
 * basic_apps.c
 *
 *  Created on: 26 Apr 2018
 *      Author: dadan
 */
#include "basic_apps.h"
#include "canvas.h"
#include "epd_1_54.h"
#include "buttons.h"

extern image_buffer_t image_buffer;
extern

void app_set_time(volatile time_t *time)
{
	time_t new_time;

	new_time.hours = time->hours;
	new_time.minutes = time->minutes;


	epd_reset();			// todo: wasting with power in delay loops
	epd_init_partial(DISPLAY_TEMPERTURE);
	epd_clear_frame_memory(COLOR_WHITE);

	// wait until all buttons are depressed
	while (button_pressed());

	int current_digit = 1;
	while (current_digit <= 4)
	{

#ifdef EPD_SIZE_2_13

	    canvas_display_from_flash(&image_buffer, &time_font[new_time.hours / 10], 8, 176, (current_digit == 1) ? 0 : 1);	// fist digit
	    canvas_display_from_flash(&image_buffer, &time_font[new_time.hours % 10], 8, 128, (current_digit == 2) ? 0 : 1);	// second digit

	    canvas_display_from_flash(&image_buffer, &time_font[10], 8, 120, 1);	// delimiter

	    canvas_display_from_flash(&image_buffer, &time_font[new_time.minutes / 10], 8, 72, (current_digit == 3) ? 0 : 1);	// third digit
	    canvas_display_from_flash(&image_buffer, &time_font[new_time.minutes % 10], 8, 24, (current_digit == 4) ? 0 : 1);		// fourth digit
#endif

	    epd_display_frame();

	    // set up idle timer
		sw_timer[SW_TIMER_IDLE] = IDLE_TIME;
		while (!button_pressed())		// wait until any button pressed
		{
			if (sw_timer[SW_TIMER_IDLE] == 0)	// or until time runs out
				return;
		}


	    if (button2_state())
	    	++ current_digit;

	    if (button3_state())
	    {
	    	// increment current digit
	    	if (current_digit == 1)		// increment tens of hours
	    	{
	    		if ((new_time.hours / 10) < 2)
	    			new_time.hours += 10;
	    		else
	    			new_time.hours = new_time.hours % 10;
	    	}

	    	if (current_digit == 2)		// increment hours
	    	{
	    		if ((new_time.hours / 10) < 2)		// 00h - 19h
	    		{
	    			if ((new_time.hours % 10) < 9)
	    				new_time.hours += 1;
	    			else
	    				new_time.hours = new_time.hours / 10;
	    		}
	    		else								// 20h - 24h
	    		{
	    			if ((new_time.hours % 10) < 4)
	    				new_time.hours += 1;
	    			else
	    				new_time.hours = (new_time.hours / 10) * 10;
	    		}
	    	}

	    	if (current_digit == 3)		// increment tens of minutes
	    	{
	    		if ((new_time.minutes / 10) < 5)
	    			new_time.minutes += 10;
	    		else
	    			new_time.minutes  = new_time.minutes % 10;
	    	}

	    	if (current_digit == 4)		// increment minutes
	    	{
	    		if ((new_time.minutes % 10) < 9)
	    			new_time.minutes += 1;
	    		else
	    			new_time.minutes  = (new_time.minutes / 10) * 10;
	    	}

	    }

	}

	time->hours = new_time.hours;
	time->minutes = new_time.minutes;
	time->seconds = 0;

	// wait until all buttons are depressed
	while (button_pressed());

}

void app_status_screen(void)
{
	epd_reset();			// todo: wasting with power in delay loops
	epd_init_partial(DISPLAY_TEMPERTURE);
	epd_clear_frame_memory(COLOR_WHITE);

	// wait until all buttons are depressed
	while (button_pressed());

	canvas_display_text(&image_buffer,&font24, "Hello!", 48, 70, 1);

	epd_display_frame();

	sw_timer[SW_TIMER_IDLE] = IDLE_TIME;
	while (!button_pressed())		// wait until any button pressed
	{
		if (sw_timer[SW_TIMER_IDLE] == 0)	// or until time runs out
			return;
	}

	// wait until all buttons are depressed
	while (button_pressed());
}

